package editorListener.listeners;

import org.eclipse.ui.IPerspectiveDescriptor;
import org.eclipse.ui.IPerspectiveListener;
import org.eclipse.ui.IWorkbenchPage;

import editorListener.handlers.EditorListener;

/**
 * This class listens to changes in the perspective. Primarily to check if a
 * editor has closed.
 * 
 * @author Matthew Harward
 * @version 4/8/2009
 */
public class PerspectiveDispatch extends Dispatch implements
		IPerspectiveListener {

	@Override
	public void perspectiveActivated(IWorkbenchPage page,
			IPerspectiveDescriptor perspective) {
	}

	@Override
	public void perspectiveChanged(IWorkbenchPage page,
			IPerspectiveDescriptor perspective, String changeId) {
		if (changeId.equals(IWorkbenchPage.CHANGE_EDITOR_CLOSE)) {
			EditorListener.getInstance().documentClosed(null);
		}
	}

}
