package editorListener.listeners;

import org.eclipse.ui.IWindowListener;
import org.eclipse.ui.IWorkbenchWindow;

import editorListener.handlers.EditorListener;

/**
 * This singleton class listens to changes in the current instance of Eclipse's
 * window management. Primarily uses close events. Activation/deactivation
 * (focus) not used currently.
 * 
 * @author Matthew Harward
 * @version 4/8/2009
 */
public class WindowDispatch extends Dispatch implements IWindowListener {

	protected static WindowDispatch wDispatch;

	protected WindowDispatch() {

	}

	public static IWindowListener getInstance() {
		if (wDispatch == null)
			wDispatch = new WindowDispatch();
		return wDispatch;
	}

	@Override
	public void windowActivated(IWorkbenchWindow window) {
	}

	@Override
	public void windowClosed(IWorkbenchWindow window) {
		EditorListener.getInstance().documentClosed(null);
	}

	@Override
	public void windowDeactivated(IWorkbenchWindow window) {
	}

	@Override
	public void windowOpened(IWorkbenchWindow window) {
	}

}
