package metricsOverlay;

import metricsOverlay.api.MetricOverlayFactory;
import java.net.URL;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IStartup;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * The activator class controls the plug-in life cycle.
 * 
 * @author Matthew Harward
 * @version 1/7/2009
 */
public class Activator extends AbstractUIPlugin implements IStartup{
	
	// The plug-in ID
	public static final String PLUGIN_ID = "MetricsOverlay";

	// The shared instance
	private static Activator plugin;
	
	/**
	 * The constructor
	 */
	public Activator() {
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		//ConfigView.getInstance();
		//SelectionView sv = new SelectionView();
		// Sets up the buffer listener.
		//FileBuffers.getTextFileBufferManager().addFileBufferListener(new FileBufferDispatch());
		// Sets up a focus tracker to get the initial focus when the workbench is created.
		//FocusTracker.getInstance().checkEditors();
		//SimpleLOCProvider.getInstance(); //--For testing
		//PlatformUI.getWorkbench().getActiveWorkbenchWindow().
		//getActivePage().showView("metricsOverlay.views.ConfigView", null, IWorkbenchPage.VIEW_CREATE );
		///PlatformUI.getWorkbench().getActiveWorkbenchWindow().
		//getActivePage().showView("metricsOverlay.views.ConfigView", null, IWorkbenchPage.VIEW_VISIBLE );
		MetricOverlayFactory.instance();
		
		plugin = this;
		
		String relativeURL = "icons/unchecked.gif";
		Image image = plugin.getImageRegistry().get( relativeURL );
		if ( image == null ) {
		  URL imageURL = plugin .getBundle().getEntry( relativeURL );
		  ImageDescriptor descriptor = ImageDescriptor.createFromURL(imageURL);
		  image = descriptor.createImage();
		  plugin.getImageRegistry().put( relativeURL , image );
		}
		relativeURL = "icons/checked.gif";
		image = plugin.getImageRegistry().get( relativeURL );
		if ( image == null ) {
		  URL imageURL = plugin .getBundle().getEntry( relativeURL );
		  ImageDescriptor descriptor = ImageDescriptor.createFromURL(imageURL);
		  image = descriptor.createImage();
		  plugin.getImageRegistry().put( relativeURL , image );
		}
		relativeURL = "icons/smalledit.gif";
		//relativeURL = "icons/midedit.gif";
		image = plugin.getImageRegistry().get( relativeURL );
		if ( image == null ) {
		  URL imageURL = plugin .getBundle().getEntry( relativeURL );
		  ImageDescriptor descriptor = ImageDescriptor.createFromURL(imageURL);
		  image = descriptor.createImage();
		  plugin.getImageRegistry().put( relativeURL , image );
		}
		relativeURL = "icons/smallremove.gif";
		image = plugin.getImageRegistry().get( relativeURL );
		if ( image == null ) {
		  URL imageURL = plugin .getBundle().getEntry( relativeURL );
		  ImageDescriptor descriptor = ImageDescriptor.createFromURL(imageURL);
		  image = descriptor.createImage();
		  plugin.getImageRegistry().put( relativeURL , image );
		}
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static Activator getDefault() {
		return plugin;
	}

	@Override
	public void earlyStartup() {
		//This plugin currently starts after the workbench is intialised.
		//At this point it is deemed that early startup is unnecessary.
	}

}
