package metricsOverlay;

import java.util.HashSet;
import java.util.Set;

import org.eclipse.swt.graphics.Color;

import metricsOverlay.model.augmentation.Augmentation;
import metricsOverlay.model.augmentation.BackgroundLineAugmentation;
import metricsOverlay.model.augmentation.MarginAugmentation;
import metricsOverlay.model.augmentation.UnderlineAugmentation;
import metricsOverlay.model.augmentation.other.ShapeDirection;
import metricsOverlay.model.augmentation.other.ShapeType;
import metricsOverlay.model.augmentation.other.UnderlineType;

public class DefaultAugmentations {

	public static Set<Augmentation> getDefaultAugmentations() {
		Set<Augmentation> augs = new HashSet<Augmentation>();
		//Augmentation 1 - Background Colouring
		BackgroundLineAugmentation flAug = new BackgroundLineAugmentation("Red Line Background");
		flAug.addColor(new Color(null, 150, 110, 110));
		flAug.addColor(new Color(null, 250, 230,230));
		flAug.setImportance(50);
		flAug.setAnnotations(true);
		flAug.setEditable(false);
		augs.add(flAug);
		//Augmentation 2 - Right RGB Arrow In
		MarginAugmentation mAug = new MarginAugmentation("Right Side Discrete RGB Arrow");
		mAug.addColor(new Color(null, 250,30,30));
		mAug.addColor(new Color(null, 30,250,30));
		mAug.addColor(new Color(null, 30,30,250));
		mAug.setDiscrete(true);
		mAug.setImportance(50);
		mAug.setAnnotations(true);
		mAug.setIsLeft(false);
		mAug.setShape(ShapeType.largetriangle, ShapeDirection.left);
		mAug.setEditable(false);
		augs.add(mAug);
		//Augmentation 3 - Blue Underline
		UnderlineAugmentation uAug = new UnderlineAugmentation("Blue Underline");
		uAug.setDiscrete(true);
		uAug.addColor(new Color(null, 30,30,250));
		uAug.setDiscrete(true);
		uAug.setImportance(50);
		uAug.setAnnotations(true);
		uAug.setUnderlineType(UnderlineType.SwiggleUnderline);
		uAug.setEditable(false);
		augs.add(uAug);
		//Return
		return augs;
	}
}
