package metricsOverlay.api;

import java.util.Observer;

import metricsOverlay.model.MetricDocument;

import org.eclipse.core.runtime.IPath;

/**
 * The interface to the program's main API. Calling these methods
 * allows an extension to this plug-in to provide live metric data.
 * 
 * @author Matthew Harward
 * @version 1/7/2009
 */
public interface IMetricOverlay extends Observer {
	
	/**
	 * Creates a metric document for a specific file.
	 * 
	 * @param fileName a String representation of the underlying file's path and name.
	 * The path should be an absolute representation. 
	 * @return an empty <code>MetricDocument</code> for a specific file.
	 */
	public MetricDocument createMetricDocument(String fileName);
	
	/**
	 * Creates a metric document for a specific file.
	 * @param fileName an IPath representation of the file's path and name.
	 * @return an empty <code>MetricDocument</code> for a specific file.
	 */
	public MetricDocument createMetricDocument(IPath fileName);
	
}
