package metricsOverlay.api;

import java.util.Observable;

import metricsOverlay.handlers.MetricFile;
import metricsOverlay.handlers.MetricFileHandler;
import metricsOverlay.model.MetricDocument;
import metricsOverlay.xml.XMLManager;

import org.eclipse.core.runtime.IPath;

import editorListener.handlers.UpdatedEditor;

public class MetricOverlayAPI implements IMetricOverlay{
	
	// Fields
	private XMLManager xmlManager;
	
	/**
	 * The main constructor for this class.
	 */
	protected MetricOverlayAPI(){
		xmlManager = XMLManager.getInstance();
	}
	
	@Override
	public void update(Observable arg0, Object arg1) {
		//Using Provided MetricFile
		if(arg1 instanceof MetricFile) {
			System.out.println("Update Overlay!" + ((MetricFile)arg1).getPath().toOSString());
			MetricFileHandler.getInstance().update((MetricFile)arg1,false);
		//Using XML
		} else if(arg1 instanceof UpdatedEditor) {
			UpdatedEditor edit = (UpdatedEditor) arg1;
			MetricFile mf = new MetricFile(xmlManager.locateXML(edit.getPath()),edit);
			MetricFileHandler.getInstance().update(mf,false);
		} else if (arg1 == null) {
			//Do Nothing
		} else {
			//Do Nothing
		}
	}
	
	// Direct implementations of files from IMetricOverlay

	@Override
	public MetricDocument createMetricDocument(String fileName) {
		fileName = normaliseFileName(fileName);
		return new MetricDocument(fileName);
	}

	@Override
	public MetricDocument createMetricDocument(IPath fileName) {
		String file = normaliseFileName(fileName.toOSString());
		return new MetricDocument(file);
	}

	private String normaliseFileName(String string) {
		// Currently this method does nothing
		return string;
	}
	
}
