package metricsOverlay.augmentationStrategies;

import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.IViewportListener;

import metricsOverlay.handlers.MetricFile;
import metricsOverlay.model.mappings.Mapping;


public class ForcedDisplayStrategy extends AugmentationStrategy {

	private IViewportListener vListener;
	
	@Override
	public void update(MetricFile mf, Mapping mm) {
		super.update(mf, mm);
		textWidget.getDisplay().asyncExec(new Runnable() {
			@Override
			public void run() {
				try {
					viewer.reinitializeProjection();
				} catch (BadLocationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				textWidget.redraw();
				textWidget.update();
			}
		});
		
		vListener = new IViewportListener() {
			@Override
			public void viewportChanged(int vOffset) {
				textWidget.redraw();
				textWidget.update();
			}
		};
		viewer.addViewportListener(vListener);
	}
/*
	@Override
	protected void applyProperties(Map<String, String> prop) {
		//null
		
	}
*/
	@Override
	public void dispose() {
		viewer.removeViewportListener(vListener);
		
	}
/*
	@Override
	public int getAugMax() {
		return 0;
	}

	@Override
	public int getAugMin() {
		return 0;
	}
*/
}
