package metricsOverlay.augmentationStrategies;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import metricsOverlay.handlers.MetricFile;
import metricsOverlay.model.MetricSection;
import metricsOverlay.model.augmentation.UnderlineAugmentation;
import metricsOverlay.model.augmentation.other.UnderlineType;
import metricsOverlay.model.mappings.Mapping;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.graphics.Color;

public class UnderlineStrategy extends AugmentationStrategy{

	//private TwoColorManager cManager;
	//private int uType;
	private ModifyListener mListener;

	public UnderlineStrategy() {
	}

	//public TwoColorManager getColorManager() {
		//return cManager;
	//}

	//@Override
	/*public int getAugMax() {
		return cManager.getRange();
	}

	@Override
	public int getAugMin() {
		return 0;
	}
	*/
	@Override
	public void update(MetricFile mf, Mapping mm) {
		super.update(mf, mm);
		mListener = new ModifyListener() {

			@Override
			public void modifyText(ModifyEvent e) {
				textWidget.getDisplay().asyncExec(new Runnable() {
					@Override
					public void run() {
						Mapping curMap = mapping;
						UnderlineAugmentation uAug = (UnderlineAugmentation)curMap.getAugmentation();
						int uType = 0;
						//Set utype in SWT form...
						UnderlineType ut = uAug.getUnderlineType();
						if(ut.equals(UnderlineType.DoubleUnderline))
							uType = SWT.UNDERLINE_DOUBLE;
						else if(ut.equals(UnderlineType.SingleUnderline))
							uType = SWT.UNDERLINE_SINGLE;
						else if(ut.equals(UnderlineType.SwiggleUnderline))
							uType = SWT.UNDERLINE_SQUIGGLE;
						else if(ut.equals(UnderlineType.LinkUnderline))
							uType = SWT.UNDERLINE_LINK;
						else uType = SWT.UNDERLINE_SQUIGGLE;
						//Carry out actual augmentation
						for (MetricSection mSec : curMap.getMetric().getMetricSections()) {
							StyleRange[] srArr = textWidget.getStyleRanges(getOffset(mSec),
									getLength(mSec));
							Set<StyleRange> styRangeSet = new HashSet<StyleRange>();
							if (srArr != null)
								styRangeSet.addAll(Arrays.asList(srArr));
							int a = curMap.getInterpolatedValue(mSec.getValue());
							Color curColor = uAug.getCManager().getColor(a);
							for (StyleRange range : styRangeSet) {
								range.underline = true;
								range.underlineStyle = uType;
								range.underlineColor = curColor;
								textWidget.setStyleRange(range);
							}
						}
						textWidget.redraw();
					}
				});
			}
		};
		
		textWidget.addModifyListener(mListener);
		
	}
/*
	@Override
	protected void applyProperties(Map<String, String> prop) {
		SortedMap<Integer, Color> cMap = new TreeMap<Integer, Color>();
		Iterator<String> it = prop.keySet().iterator();
		while (it.hasNext()) {
			String s = it.next();
			String value = prop.get(s);
			if (s.startsWith(MappingProperties.COLOR)) {
				int i = Integer.parseInt(s.substring(MappingProperties.COLOR
						.length()));
				Color c = parseColor(value);
				cMap.put(i, c);
			} else if (s.equals(MappingProperties.UNDERLINETYPE)){
				if(value.equals(MappingProperties.ULINE_DOUBLE))
					uType = SWT.UNDERLINE_DOUBLE;
				else if(value.equals(MappingProperties.ULINE_SINGLE))
					uType = SWT.UNDERLINE_SINGLE;
				else if(value.equals(MappingProperties.ULINE_SQUIGGLE))
					uType = SWT.UNDERLINE_SQUIGGLE;
				else if(value.equals(MappingProperties.ULINE_LINK))
					uType = SWT.UNDERLINE_LINK;
				else uType = SWT.UNDERLINE_SQUIGGLE;
			}
		}
		if (cMap.size() > 1) {
			Iterator<Integer> itint = cMap.keySet().iterator();
			cManager.setLow(cMap.get(itint.next()));
			cManager.setHigh(cMap.get(itint.next()));
		}
		
	}*/

	@Override
	public void dispose() {
		textWidget.removeModifyListener(mListener);
		textWidget.redraw();
	}

}
