package metricsOverlay.colorManagers;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.graphics.Color;

/**
 * This colour manager takes in a list of colours, and then provides an interpolated result
 * between the each of the colours specified.
 * 
 * @author Matthew Harward
 * @version 5/7/2009
 */
public class ContinuousListColorManager implements IColorManager{
	
	private List<Color> cList;

	public ContinuousListColorManager() {
		cList = new ArrayList<Color>();
	}
	
	public ContinuousListColorManager(List<Color> cList){
		this.cList = cList;
	}
	
	public int getNumColors() {
		return cList.size();
	}
	
	public int getRange() {
		int count = 0;
		for (int i = 0; i < cList.size() - 1; i++){
			TwoColorManager cm = new TwoColorManager(cList.get(i),cList.get(i+1));
			count += cm.getRange();
		}
		return count;
	}
	
	public void appendColor(Color a) {
		cList.add(a);
	}
	
	public Color getColor(int index) {
		//Default to white
		Color finalC = new Color(null,255,255,255);
		for(int i = 0; i < getRange();) {
			for (int j = 0; j < cList.size() - 1; j++){
				TwoColorManager cm = new TwoColorManager(cList.get(j),cList.get(j+1));
				int previ = i;
				i += cm.getRange();
				if (index <= i){
					finalC = cm.getColor(index-previ);
				}
			}
		}
		return finalC;
	}
}
