package metricsOverlay.colorManagers;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.graphics.Color;

public class DiscreteListColorManager implements IColorManager{
	
	private List<Color> cList;

	public DiscreteListColorManager() {
		cList = new ArrayList<Color>();
	}
	
	public DiscreteListColorManager(List<Color> cList){
		this.cList = cList;
	}
	
	public int getNumColors() {
		return cList.size();
	}
	
	public int getRange(){
		return getNumColors();
	}
	
	public void appendColor(Color a) {
		cList.add(a);
	}
	
	public Color getColor(int index) {
		if(index >= cList.size())
			return cList.get(cList.size()-1);
		else if (index <= 0)
			return cList.get(0);
		else
			return cList.get(index);
	}
}
