package metricsOverlay.colorManagers;

import org.eclipse.swt.graphics.Color;

public class OneColorManager implements IColorManager{

	private TwoColorManager cMan;
	private Color white;

	public OneColorManager(Color one) {
		this.white = new Color(null,255,255,255);
		cMan = new TwoColorManager(white,one);
	}
	
	public OneColorManager() {
		this(new Color(null,255,255,255));
	}

	public int getRange() {
		return cMan.getRange();
	}

	public Color getColor(int value) {
		return cMan.getColor(value);
	}

	public Color getColor() {
		return cMan.getHigh();
	}

	public void setColor(Color one) {
		cMan.setHigh(one);
	}

	@Override
	public int getNumColors() {
		return 1;
	}

}
