package metricsOverlay.editor;

import java.util.ArrayList;
import java.util.Iterator;

import org.eclipse.jdt.internal.ui.javaeditor.CompilationUnitEditor;

@SuppressWarnings("restriction")
public class LineHighlighterManager {
	
	private ArrayList<DecoratorEditor> lineHighLighters = null;
	static LineHighlighterManager instance = null;
	
	
	private LineHighlighterManager(){
		lineHighLighters = new ArrayList<DecoratorEditor>();
		
	}
	
	public void addHighLighter(CompilationUnitEditor editor) {
		
		if (!editorExists(editor)) {
			lineHighLighters.add(new DecoratorEditor(editor));
		}
	}
	
	public void removeHighLighter(CompilationUnitEditor editor) {
		
		Iterator it = lineHighLighters.iterator();
		while (it.hasNext()) {
			DecoratorEditor highlighter = (DecoratorEditor) it.next();
			if (highlighter.getEditor().equals(editor)) {
				lineHighLighters.remove(highlighter);
			}
		}
		
	}
	
	public DecoratorEditor getLineHighLighterByEditor(CompilationUnitEditor editor) {
		
		Iterator it = lineHighLighters.iterator();
		DecoratorEditor highlighter = null;
		while (it.hasNext()) {
			highlighter = (DecoratorEditor) it.next();
			if (highlighter.getEditor().equals(editor)) {
				break;
			}
		}
		return highlighter;
	}
	
	private boolean editorExists(CompilationUnitEditor editor) {
		
		boolean exists = false;
		Iterator it = lineHighLighters.iterator();
		while (it.hasNext() && !exists) {
			DecoratorEditor highlighter = (DecoratorEditor) it.next();
			exists = (editor.equals(highlighter.getEditor()));
		}
		
		return exists;
	}
	
	
	
	/**
	 * Gets an instance for this class
	 * Provides a global access point to the singleton object
	 * @return an instance of this class
	 */
	public static LineHighlighterManager getInstance() {
		if(instance == null){
			instance = new LineHighlighterManager();
		}
		return instance;
	}	
	

}
