package metricsOverlay.editor;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import metricsOverlay.model.MetricDocument;
import metricsOverlay.model.mappings.Mapping;
import metricsOverlay.xml.XMLManager;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.jdt.internal.ui.javaeditor.CompilationUnitEditor;
import org.eclipse.jdt.internal.ui.javaeditor.JavaEditor;
import org.eclipse.jface.text.IDocument;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;

public class OpenFileIndexingService {

	// Singleton object
	private static OpenFileIndexingService opis;
	
	//Fields
	private Map<IPath,IDocument> docMap;
	private List<Mapping> list;
	
	private OpenFileIndexingService(){
		docMap = new HashMap<IPath,IDocument>();
	}
	
	public static OpenFileIndexingService getInstance() {
		if(opis == null)
			opis = new OpenFileIndexingService();
		return opis;
	}

	@SuppressWarnings("restriction")
	public void index(IWorkbenchPart part, IDocument doc, IPath path) {
		docMap.put(path, doc);
		System.out.println("Parsing filename");
		XMLManager m = XMLManager.getInstance();
		IWorkspace ws = ResourcesPlugin.getWorkspace();
		IFile f = null;
		for(IProject p : ws.getRoot().getProjects()){
			f = p.getFile(path.removeFirstSegments(1));
			if(f != null)
				break;
		}
		String file = f.getLocationURI().toString();
		IPath ped = Path.fromOSString(file);
		System.out.println("Path:" + ped.toOSString());
		MetricDocument mapping = m.locateXML(ped);
		DecoratorEditor de = new DecoratorEditor((CompilationUnitEditor)part,mapping);
		//List<Mapping> list = new ArrayList<Mapping>();
		//list.addAll(mapping.values());
		//this.list = list;
		//TODO call Config View to update...
	}

	public List<Mapping> getMappingList(String string) {
		if(list == null)
			list = new ArrayList<Mapping>();
		Map<String,String> pro1 = new HashMap<String, String>();
		pro1.put("Name", "Test");
		//Mapping a1 = new Mapping(1,pro1);
		//a1.setMetric(new Metric("A metric"));
		//a1.setDisplay(new Augmentation(4));
		//list.add(a1);
		return list;
	}

	public void index(IDocument doc, IPath removeFileExtension) {
		IWorkbenchWindow window = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
		IWorkbenchPart part = (IWorkbenchPart)window.getActivePage().getActiveEditor();
		if(part instanceof JavaEditor){
			index(part,doc,removeFileExtension);
		}
	}

	public void doUpdate(IDocument doc) {
		// TODO Auto-generated method stub
		
	}
}
