package metricsOverlay.junitTests;

import junit.framework.TestCase;
import metricsOverlay.augmentationStrategies.AugmentationStrategy;
import metricsOverlay.model.augmentation.Augmentation;
import metricsOverlay.model.augmentation.UnderlineAugmentation;

import org.eclipse.swt.graphics.Color;

public class AugmentationTests extends TestCase {
	
	public void testAugmentation1() {
		String aname = "Bling";
		Augmentation ua = new UnderlineAugmentation(aname);
		assertNotNull(ua);
		assertEquals(50,ua.getImportance());
		assertEquals(true, ua.canEdit());
		assertEquals(true, ua.canChangeEditableStatus());
		assertEquals(true, ua.isAnnotated());
		assertEquals(false, ua.isDiscrete());
		assertEquals(aname, ua.getName());
	}

	public void testColorParse1(){
		Color a = AugmentationStrategy.parseColor("{255, 255, 255}");
		assertNotNull(a);
		assertEquals(255, a.getRed());
		assertEquals(255, a.getGreen());
		assertEquals(255, a.getBlue());
	}
	
	public void testColorParse2(){
		Color a = AugmentationStrategy.parseColor("{1, 220, 3}");
		assertNotNull(a);
		assertEquals(1, a.getRed());
		assertEquals(220, a.getGreen());
		assertEquals(3, a.getBlue());
	}
	
	public void testColorParse3(){
		Color a = AugmentationStrategy.parseColor("{1, 220, }");
		assertNull(a);
	}
	
	public void testColorParse4(){
		Color a = AugmentationStrategy.parseColor("{256, 256, 256}");
		assertNull(a);
	}
	
	public void testColorParse5(){
		Color a = AugmentationStrategy.parseColor("{-1, -2, -1, 33333}");
		assertNotNull(a);
		assertEquals(1, a.getRed());
		assertEquals(2, a.getGreen());
		assertEquals(1, a.getBlue());
	}
	
	public void testColorParse6(){
		Color a = AugmentationStrategy.parseColor("11113222");
		assertNotNull(a);
		assertEquals(111, a.getRed());
		assertEquals(132, a.getGreen());
		assertEquals(22, a.getBlue());
	}
	
}
