package metricsOverlay.junitTests;

import junit.framework.TestCase;
import metricsOverlay.model.augmentation.MarginAugmentation;
import metricsOverlay.model.mappings.Mapping;
import metricsOverlay.model.mappings.MappingState;
import metricsOverlay.model.metrics.ActualMetric;

public class MappingTests extends TestCase {

	public void testMapping1()
	{
		String mapName = "Mapping";
		Mapping m = new Mapping(mapName);
		assertNotNull(m);
		assertFalse(m.isUsable());
		assertTrue(m.canEdit());
		assertEquals(mapName,m.getName());
		assertEquals(MappingState.UndeclaredMapping, m.getMappingState());
		assertEquals(true, m.canChangeEditableStatus());
		m.setEditable(false);
		assertEquals(false, m.canEdit());
	}
	
	public void testMappingIntegration()
	{
		String mapName = "Mapping";
		Mapping m = new Mapping(mapName);
		MarginAugmentation ma = new MarginAugmentation("Blah");
		ActualMetric actMet = new ActualMetric("A metric");
		m.setAugmentation(ma);
		m.setMetric(actMet);
		assertEquals(true, m.isUsable());
		int a = m.getInterpolatedValue("5");
		assertEquals(0,a);
	}
	
}
