package metricsOverlay.junitTests;

import metricsOverlay.model.metrics.IntegerRange;
import metricsOverlay.model.metrics.ActualMetric;
import metricsOverlay.model.metrics.Range;
import junit.framework.TestCase;

public class MetricTests extends TestCase {

	public void testMetrics1()
	{
		String name = "A metric";
		ActualMetric m = new ActualMetric(name);
		assertNotNull(m);
		assertEquals(name,m.getName());
		name = "blah";
		m.setName(name);
		assertEquals(name,m.getName());
		assertEquals("100",m.getRange().getMax());
		assertEquals("1",m.getRange().getMin());
	}
	
	public void testMetrics2()
	{
		String name = "A metric";
		Range r = new IntegerRange(2, 24);
		ActualMetric m = new ActualMetric(name,r);
		assertNotNull(m);
		assertEquals(name,m.getName());
		name = "blah";
		m.setName(name);
		assertEquals(name,m.getName());
		assertEquals("24",m.getRange().getMax());
		assertEquals("2",m.getRange().getMin());
		assertEquals(r,m.getRange());
	}
	
}
