package metricsOverlay.junitTests;

import metricsOverlay.model.metrics.CompositeIntegerRange;
import metricsOverlay.model.metrics.CompositeRealRange;
import metricsOverlay.model.metrics.IntegerRange;
import metricsOverlay.model.metrics.OrderedNominalRange;
import metricsOverlay.model.metrics.Range;
import metricsOverlay.model.metrics.RealRange;
import junit.framework.TestCase;

public class RangeTests extends TestCase {

	public void testRange1()
	{
		Range r = new RealRange(4.3,2.4);
		assertNotNull(r);
		assertEquals(false,r.isValid());
		
		Range r2 = new RealRange(2.1,4.4);
		assertNotNull(r2);
		assertEquals(true,r2.isValid());
		assertEquals("2.1", r2.getMin());
		assertEquals("4.4", r2.getMax());
		assertEquals(false, r2.isInRange("2.09999"));
		assertEquals(false, r2.isInRange("4.40001"));
		assertEquals(false, r2.isInRange("0"));
		assertEquals(true, r2.isInRange("4.4"));
		assertEquals(true, r2.isInRange("2.1"));
		assertEquals(true, r2.isInRange("3.5"));
		
		Range r4 = new RealRange();
		assertNotNull(r4);
		//This could need changing...
		assertEquals(false,r4.isValid());
	}
	
	public void testRange2()
	{		
		Range r3 = new IntegerRange(1,10);
		assertNotNull(r3);
		assertEquals(true,r3.isValid());
		assertEquals("1", r3.getMin());
		assertEquals("10", r3.getMax());
		assertEquals(false, r3.isInRange("20"));
		assertEquals(false, r3.isInRange("0"));
		assertEquals(false, r3.isInRange("11"));
		assertEquals(true, r3.isInRange("1"));
		assertEquals(true, r3.isInRange("10"));
		
		Range r5 = new IntegerRange(21,10);
		assertNotNull(r5);
		assertEquals(false,r5.isValid());
		
		Range r4 = new IntegerRange();
		assertNotNull(r4);
		//This could need changing...
		assertEquals(false,r4.isValid());
	}
	
	public void testRange3() {
		Range r1 = new OrderedNominalRange();
		assertNotNull(r1);
		assertEquals(false,r1.isValid());
	}
	
	public void testRange4() {
		Range r1 = new CompositeIntegerRange();
		assertNotNull(r1);
		assertEquals(false,r1.isValid());
	}
	
	public void testRange5() {
		Range r1 = new CompositeRealRange();
		assertNotNull(r1);
		assertEquals(false,r1.isValid());
	}
}
