package metricsOverlay.junitTests;

import java.io.File;

import metricsOverlay.xml.XMLManager;

import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;

import junit.framework.TestCase;

public class XMLManagerTests extends TestCase {
	
	public void testPathGeneration1(){
		String pathString = "C:/Users/Person/Blah/workspace/Project/src/Package/File.java";
		String finalString = "C:/Users/Person/Blah/workspace/Project/metricsxml/Package/File.xml";
		IPath n = Path.fromOSString(pathString);
		String a = XMLManager.extractXMLPath(n);
		//System.out.println(a);
		assertEquals(Path.fromOSString(finalString),Path.fromOSString(a));
	}
	
	public void testPathGeneration2(){
		String pathString = "C:/Users/Person/Blah/Yep/workspace/Project/src/Package/Bling/Bloo/File.java";
		String finalString = "C:/Users/Person/Blah/Yep/workspace/Project/metricsxml/Package/Bling/Bloo/File.xml";
		IPath n = Path.fromOSString(pathString);
		String a = XMLManager.extractXMLPath(n);
		//System.out.println(a);
		assertEquals(Path.fromOSString(finalString),Path.fromOSString(a));
	}
	
	public void testPathGeneration3(){
		String pathString = "C:/Yep/workspace/Project/src/Package/Bling/Bloo/File.java";
		String finalString = "C:/Yep/workspace/Project/metricsxml/Package/Bling/Bloo/File.xml";
		IPath n = Path.fromOSString(pathString);
		String a = XMLManager.extractXMLPath(n);
		//System.out.println(a);
		assertEquals(Path.fromOSString(finalString),Path.fromOSString(a));
	}
	
	public void testPathGenerationNoSource1(){
		String pathString = "C:/Users/Person/Blah/Yep/workspace/Project/Package/Bling/Bloo/File.java";
		String finalString = "C:/Users/Person/Blah/Yep/workspace/Project/Package/Bling/Bloo/packagemetricsxml/File.xml";
		IPath n = Path.fromOSString(pathString);
		String a = XMLManager.extractXMLPath(n);
		//System.out.println(a);
		assertEquals(Path.fromOSString(finalString),Path.fromOSString(a));
	}
	
	public void testPathGenerationNoSource2(){
		String pathString = "C:/Users/Person/Src/Users/Person/Blah/SRC/workspace/Project/Package/Bling/Bloo/File.java";
		String finalString = "C:/Users/Person/Src/Users/Person/Blah/SRC/workspace/Project/Package/Bling/Bloo/packagemetricsxml/File.xml";
		IPath n = Path.fromOSString(pathString);
		String a = XMLManager.extractXMLPath(n);
		//System.out.println(a);
		assertEquals(Path.fromOSString(finalString),Path.fromOSString(a));
	}
	
	public void testDTDPath() {
		//System.out.println(XMLManager.getAbsoluteDTDPath());
		File f = new File(XMLManager.getAbsoluteDTDPath());
		assertEquals(true,f.canRead());
	}
}
