package metricsOverlay.junitTests;

import junit.framework.TestCase;
import metricsOverlay.model.MetricDocument;
import metricsOverlay.model.augmentation.UnderlineAugmentation;
import metricsOverlay.model.metrics.Metric;
import metricsOverlay.xml.MetricXMLReader;
import metricsOverlay.xml.MetricXMLWriter;
import metricsOverlay.xml.XMLManager;

public class XMLTests extends TestCase {

	private static final String aFileName = "file.java";
	private static final String testXML = "/src/metricsOverlay/junitTests/test1.xml";
	private static final String testXML2 = "/src/metricsOverlay/junitTests/test2.xml";
	
	public void setUp(){
	}
	
	public void testMetricXMLReader1() {
		MetricXMLReader mRead = new MetricXMLReader(aFileName);
		String xmlFileName = XMLManager.getAbsoluteLocalPath(testXML);
		mRead.readXML(xmlFileName);
		assertNotNull(mRead.getMetricDocument());
	}
	
	public void testMetricXMLReader2() {
		MetricXMLReader mRead = new MetricXMLReader(aFileName);
		String xmlFileName = XMLManager.getAbsoluteLocalPath(testXML);
		mRead.readXML(xmlFileName);
		assertNotNull(mRead.getMetricDocument());
		MetricDocument result = mRead.getMetricDocument();
		assertEquals(1,result.numAugmentations());
		assertEquals(1,result.numMappings());
		assertEquals(3,result.numMetrics());
		assertEquals(123456,result.getTimeStamp().getTime());
		for(Metric met : result.getAllMetrics())
			assertEquals(1,met.getMetricSections().size());
		assertTrue(result.getAllAugmentations().iterator().next() 
				instanceof UnderlineAugmentation);
	}
	
	public void testMetricXMLWriter1() {
		MetricXMLReader mRead = new MetricXMLReader(aFileName);
		String xmlFileName = XMLManager.getAbsoluteLocalPath(testXML);
		mRead.readXML(xmlFileName);
		assertNotNull(mRead.getMetricDocument());
		MetricDocument result = mRead.getMetricDocument();
		MetricXMLWriter mWrite = new MetricXMLWriter(result);
		mWrite.writeFile(XMLManager.getAbsoluteLocalPath(testXML2));
	}

}
