package metricsOverlay.model;

/**
 * This interface provides model elements with the ability to name and rename
 * themselves.
 * 
 * @author Matthew Harward
 * @version 27/8/2009
 */
public interface INameable {

	/**
	 * @return A String that is unique among this object type and provides a
	 *         human readable title.
	 */
	public String getName();

	/**
	 * This method sets the name of a nameable object. This name should be
	 * unique among objects of this type.
	 * 
	 * @param name
	 *            the unique name to be set.
	 */
	public void setName(String name);
}
