package metricsOverlay.model.augmentation;

import metricsOverlay.augmentationStrategies.BgLineStrategy;
import metricsOverlay.handlers.MetricFile;
import metricsOverlay.model.mappings.Mapping;


public class BackgroundLineAugmentation extends Augmentation {

	private BgLineStrategy lnStrat;

	public BackgroundLineAugmentation() {
		super();
	}
	
	public BackgroundLineAugmentation(String augName) {
		super(augName);
	}

	public String getType() {
		return "Background Line Augmentation";
	}

	@Override
	public void disable() {
		if(lnStrat != null)
			lnStrat.dispose();
		lnStrat = null;
	}

	@Override
	public void update(MetricFile mf, Mapping mm) {
		if(lnStrat == null)
			lnStrat = new BgLineStrategy();
		lnStrat.update(mf, mm);
		
	}
	

}
