package metricsOverlay.model.augmentation;

import metricsOverlay.augmentationStrategies.BgSectionStrategy;
import metricsOverlay.handlers.MetricFile;
import metricsOverlay.model.mappings.Mapping;

public class BackgroundSectionAugmentation extends SectionAugmentation {

	private BgSectionStrategy bgStrat;

	public BackgroundSectionAugmentation() {
	}
	
	public BackgroundSectionAugmentation(String name) {
		super(name);
	}

	public String getType() {
		return "Background Section Augmentation";
	}
	
	@Override
	public void disable() {
		if(bgStrat != null)
			bgStrat.dispose();
		bgStrat = null;
	}
	
	@Override
	public void update(MetricFile mf, Mapping mm) {
		if(bgStrat == null)
			bgStrat = new BgSectionStrategy();
		bgStrat.update(mf, mm);
	}
}
