package metricsOverlay.model.augmentation;

import metricsOverlay.augmentationStrategies.UnderlineStrategy;
import metricsOverlay.handlers.MetricFile;
import metricsOverlay.model.augmentation.other.UnderlineType;
import metricsOverlay.model.mappings.Mapping;

public class UnderlineAugmentation extends SectionAugmentation{

	private UnderlineType uType;
	private UnderlineStrategy uStrat;
	
	public UnderlineAugmentation() {
		
	}
	
	public UnderlineAugmentation(String name) {
		super(name);
	}

	public String getType() {
		return "Underline Augmentation";
	}
	
	public void setUnderlineType(UnderlineType uType) {
		this.uType = uType;
	}
	
	public UnderlineType getUnderlineType() {
		return uType;
	}
	
	@Override
	public void update(MetricFile mf, Mapping mm) {
		if(uStrat == null)
			uStrat = new UnderlineStrategy();
		uStrat.update(mf, mm);
	}

	@Override
	public void disable() {
		if(uStrat != null)
			uStrat.dispose();
		uStrat = null;
	}
}
