package metricsOverlay.model.mappings;

public class AugmentExponentialIStrategy extends ExponentialIStrategy {

	public AugmentExponentialIStrategy(){
		super();
	}
	
	public AugmentExponentialIStrategy(double dMax, double dMin, double mMax,
			double mMin, double exp) {
		super(dMax, dMin, mMax, mMin, exp);
	}

	@Override
	public int getInterpolatedValue(String value) {
		double val = Double.parseDouble(value);	
		double b = (Math.pow(dMax, exp) - Math.pow(dMin, exp))
				/ (mMax - mMin);
		double a = Math.pow(dMax, exp) - b * (mMax);
		double finalVal = Math.pow(a + b * val, 1.0 / exp);
		return (int) finalVal;
	}
	
	@Override
	public String getType() {
		return "Exponential Interpolation (Augmentation)";
	}
	
}
