package metricsOverlay.model.mappings;

public class AugmentLogIStrategy extends LogIStrategy {

	public AugmentLogIStrategy(){
		super();
	}
	
	public AugmentLogIStrategy(double dMax, double dMin, double mMax,
			double mMin, double log) {
		super(dMax, dMin, mMax, mMin, log);
	}

	@Override
	public int getInterpolatedValue(String value) {
		double val = Double.parseDouble(value);	
		double b = (Math.log10(dMax
				/ dMin) / Math.log10(log))
				/ (mMax - mMin);
		double a = Math.log10(dMax) / Math.log10(log)
				- b * (mMax);
		// Using the log power law - x=logb(a) => b^x = a
		double finalVal = Math.pow(log, a + b * val);
		return (int) finalVal;
	}

	@Override
	public String getType() {
		return "Log Interpolation (Augmentation)";
	}
}
