package metricsOverlay.model.mappings;

public class LinearIStrategy extends InterpolationStrategy {

	public LinearIStrategy() {
		super();
	}
	
	public LinearIStrategy(double dMax, double dMin, double mMax, double mMin) {
		super(dMax, dMin, mMax, mMin);
	}

	@Override
	public int getInterpolatedValue(String value) {
		double val = Double.parseDouble(value);
		double b = (dMax - dMin) / (mMax - mMin);
		double a = dMax - b * mMax;
		// Standard regression - y = a + bx
		double finalVal = a + b * val;
		return (int) finalVal;
	}

	@Override
	public String getType() {
		return "Linear Interpolation";
	}

}
