package metricsOverlay.model.mappings;

/**
 * This enum represents the state of the mapping it is attached to.
 * 
 * <ul>
 * <li><b>StubMapping:</b> This mapping is unused and is generated purely for
 * testing purposes.</li>
 * <li><b>UndeclaredMapping:</b> This mapping is not visible in the editor and
 * is not in the table of mappings in the provided view. It may however be added,
 * at which point its state will be upgraded.</li>
 * <li><b>DeclaredMapping:</b> This type of mapping is visible in the selected
 * view. However not in the code editor.</li>
 * <li><b>ActiveMapping:</b> This type of mapping is visible in the editor 
 * (as long as the main on/off toggle is selected) and 
 * appears selected in the table. </li>
 * </ul>
 * 
 * @author Matthew Harward
 * @version 12/8/2009
 */
public enum MappingState {
	StubMapping, UndeclaredMapping, DeclaredMapping, ActiveMapping;
}
