package metricsOverlay.model.mappings;

public class MetricExponentialIStrategy extends ExponentialIStrategy {

	public MetricExponentialIStrategy(){
		super();
	}
	
	public MetricExponentialIStrategy(double dMax, double dMin, double mMax,
			double mMin, double exp) {
		super(dMax, dMin, mMax, mMin, exp);
	}

	@Override
	public int getInterpolatedValue(String value) {
		double val = Double.parseDouble(value);		
		double b = (dMax - dMin)
		/ (Math.pow(mMax, exp) - Math.pow(mMin, exp));
		double a = dMax - b * (Math.pow(mMax, exp));
		double finalVal = a + b * Math.pow(val, exp);
		return (int) finalVal;
	}
	
	@Override
	public String getType() {
		return "Exponential Interpolation (Metric)";
	}
	
}
