package metricsOverlay.model.mappings;

public class MetricLogIStrategy extends LogIStrategy {
	
	public MetricLogIStrategy() {
		super();
	}
	
	public MetricLogIStrategy(double dMax, double dMin, double mMax,
			double mMin, double log) {
		super(dMax, dMin, mMax, mMin, log);
	}

	@Override
	public int getInterpolatedValue(String value) {
		double val = Double.parseDouble(value);	
		double b = (dMax - dMin)
		/ ((Math.log10(mMax)/ mMin) / Math.log10(log));
		double a = dMax - b
		* (Math.log10(mMax) / Math.log10(log));
		double finalVal = a + b * Math.log10(val) / Math.log10(log);
		return (int) finalVal;
	}
	
	@Override
	public String getType() {
		return "Log Interpolation (Metric)";
	}
	
}
