package metricsOverlay.views.toolbar;

import metricsOverlay.handlers.MetricFileHandler;
import metricsOverlay.model.mappings.MappingState;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.core.commands.IHandlerListener;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.ui.PlatformUI;

public class ClearAllMappingsHandler implements IHandler {

	@Override
	public void addHandlerListener(IHandlerListener handlerListener) {}

	@Override
	public void dispose() {}

	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		if(MessageDialog.open(MessageDialog.QUESTION, PlatformUI.getWorkbench()
			.getActiveWorkbenchWindow().getShell(), 
			"Clear All Mappings", "Are you sure you want to clear all active mappings?", 
			SWT.NONE))
		{
			MetricFileHandler.getInstance().getCurrentMFile()
				.getMetricDocument().setAllMappingState(MappingState.UndeclaredMapping);
			//Force update...
		}
		return null;
	}

	@Override
	public boolean isEnabled() {
		if(MetricFileHandler.getInstance().getCurrentMFile() == null)
			return false;
		else return true;
	}

	@Override
	public boolean isHandled() {
		return true;
	}

	@Override
	public void removeHandlerListener(IHandlerListener handlerListener) {}

}
