package metricsOverlay.xml;

/**
 * This class contains a list of strings for use by the XML reading and writing
 * classes in this package.
 * 
 * @author Matthew Harward
 * @version 25/6/2009
 */
public class XMLConstants {
	
	// Constants - General
	protected static final String XML = "xml";
	protected static final String DOCUMENT = "document";
	protected static final String FILENAME = "filename";
	protected static final String TIMESTAMP = "timestamp";
	
	protected static final String MAPPING = "mapping";
	protected static final String METRICSECTION = "metricsection";
	
	//Constants - Path Generation
	protected static final String SOURCEFOLDERNAME = "src";
	protected static final String STDXMLDIR = "/metricsxml/";
	protected static final String NOSRCXMLDIR = "/packagemetricsxml/";
	
	// Constants - Related to Metrics
	protected static final String METRIC = "metric";
	protected static final String DERIVEDMETRIC = "derivedmetric";
	protected static final String FROM = "from";
	protected static final String RANGE = "range";
	protected static final String SIMPLERANGE = "simplerange";
	protected static final String COMPOSITERANGE = "compositerange";
	protected static final String RANGEITEM = "rangeitem";
	protected static final String PROPERTY = "property";
	protected static final String NAME = "name";
	protected static final String METRICNAME = "metricName";
	protected static final String TYPE = "type";
	protected static final String MIN = "min";
	protected static final String MAX = "max";
	protected static final String REAL = "Real";
	protected static final String INTEGER = "Integer";
	protected static final String ORDEREDNOMINAL = "OrderedNominal";
	protected static final String COMPOSITEINT = "CompositeInt";
	protected static final String COMPOSITEREAL = "CompositeReal";
	
	// Constants - Related to Mapping
	protected static final String MAPPINGNAME = "mappingName";
	protected static final String AUGMENTATIONNAME = "augmentationName";
	protected static final String STATE = "state";
	protected static final String INTERMETHOD = "interpolationMethod";
	protected static final String INTERCONST = "interpolationConstant";
	protected static final String DECLARED = "Declared";
	protected static final String ACTIVE = "Active";
	
	//Constants - Interpolation Methods
	protected static final String LINEAR = "Linear";
	protected static final String METEXP = "MetricExp";
	protected static final String AUGEXP = "AugExp";
	protected static final String METLOG = "MetricLog";
	protected static final String AUGLOG = "AugLog";
	
	//Constants - Related to Augmentation
	protected static final String AUGMENTATION = "augmentation";
	protected static final String IMPORTANCE = "importance";
	protected static final String DISCRETE = "discrete";
	protected static final String ON = "on";
	protected static final String OFF = "off";
	protected static final String UNDERLINE = "underline";
	protected static final String SWIGGLE = "Swiggle";
	protected static final String LINK = "Link";
	protected static final String DOUBLE = "Double";
	protected static final String SINGLE = "Single";
	protected static final String SHAPETYPE = "shapeType";
	protected static final String SHAPEDIR = "shapeDir";
	protected static final String MARGINSIDE = "marginSide";
	protected static final String LEFT = "Left";
	protected static final String RIGHT = "Right";
	protected static final String EDITABLE = "editable";
	
	//Constants - Augmentation Types
	protected static final String MARGINTYPE = "Margin";
	protected static final String UNDERLINETYPE = "Underline";
	protected static final String BGSECTIONTYPE = "BGSection";
	protected static final String BGLINETYPE = "BGLine";
	
	//Constants - Colors in Augmentations
	protected static final String COLOR = "color";
	protected static final String RED = "red";
	protected static final String GREEN = "green";
	protected static final String BLUE = "blue";
	
	// Constants - Related to Metrics Sections
	protected static final String STARTLINE = "startline";
	protected static final String STARTCOL = "startcol";
	protected static final String ENDLINE = "endline";
	protected static final String ENDCOL = "endcol";
	protected static final String VALUE = "value";
	protected static final String ACTUALTEXT = "actualtext";
	protected static final String ANNOTATION = "annotation";
	
	//Constants - Strings related to the doctype
	protected static final String DTD = "/src/metricsOverlay/xml/metric.dtd";
	
	
	
	

	
	
	

	
	
	
	
	
	
	
	
	
	
	
	
	
	
}
